#ifndef ELM_VIEW_FORM_EO_HH
#define ELM_VIEW_FORM_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_canvas_object.eo.h"
#include "efl_model.eo.h"
#include "elm_view_form.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_canvas_object.eo.hh"
#include "efl_model.eo.hh"
#include "eo_base.eo.hh"
namespace elm { namespace view { 
struct Form;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::view::Form> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { namespace view { 
struct Form {
   ::efl::eolian::return_traits<void>::type model_set( ::efl::eolian::in_traits< ::efl::Model>::type model) const;
   ::efl::eolian::return_traits<void>::type widget_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type propname,  ::efl::eolian::in_traits< ::efl::canvas::Object>::type evas) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_VIEW_FORM_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::view::Form() const;
   operator ::elm::view::Form&();
   operator ::elm::view::Form const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Form,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Form const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace elm { namespace view { 
struct Form : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Form( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Form(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Form(Form const& other) = default;
   Form(Form&& other) = default;
   Form& operator=(Form const& other) = default;
   Form& operator=(Form&& other) = default;
   Form()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Form( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Form(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<void>::type model_set( ::efl::eolian::in_traits< ::efl::Model>::type model) const;
   ::efl::eolian::return_traits<void>::type widget_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type propname,  ::efl::eolian::in_traits< ::efl::canvas::Object>::type evas) const;
   static Eo_Class const* _eo_class()
   {
      return ELM_VIEW_FORM_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Form,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Form const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Form) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Form>::value, "");
} } 
#include "elm_view_form.eo.impl.hh"
#endif
